package com.expvintl.mctools.commands;

import com.expvintl.mctools.FeaturesBool;
import com.expvintl.mctools.events.MCEventBus;
import com.expvintl.mctools.events.player.PlayerAttackBlockEvent;
import com.expvintl.mctools.events.player.PlayerBreakBlockEvent;
import com.google.common.eventbus.Subscribe;
import com.mojang.brigadier.Command;
import com.mojang.brigadier.CommandDispatcher;
import com.mojang.brigadier.arguments.BoolArgumentType;
import com.mojang.brigadier.context.CommandContext;
import net.fabricmc.fabric.api.client.command.v2.FabricClientCommandSource;
import net.minecraft.class_1799;
import net.minecraft.class_1820;
import net.minecraft.class_1829;
import net.minecraft.class_1831;
import net.minecraft.class_2202;
import net.minecraft.class_2211;
import net.minecraft.class_2561;
import net.minecraft.class_2680;
import net.minecraft.class_310;

import static net.fabricmc.fabric.api.client.command.v2.ClientCommandManager.argument;
import static net.fabricmc.fabric.api.client.command.v2.ClientCommandManager.literal;

public class CAutoToolCommand {
    private static final CAutoToolCommand INSTANCE=new CAutoToolCommand();
    private int lastSlot=-1;
    public static void register(CommandDispatcher<FabricClientCommandSource> dispatcher){
        MCEventBus.INSTANCE.register(INSTANCE);
        dispatcher.register(literal("cautotool").then(argument("开关", BoolArgumentType.bool()).executes(CAutoToolCommand::execute)));
    }

    private static int execute(CommandContext<FabricClientCommandSource> context) {
        FeaturesBool.autoTool=context.getArgument("开关", Boolean.class);
        if(FeaturesBool.autoTool){
            context.getSource().getPlayer().method_43496(class_2561.method_43470("已启用智能工具!"));
        }else{
            context.getSource().getPlayer().method_43496(class_2561.method_43470("已禁用智能工具!"));
        }
        return Command.SINGLE_SUCCESS;
    }
    @Subscribe
    private void onBreakBlock(PlayerBreakBlockEvent event){
        if(!FeaturesBool.autoTool) return;
        class_310 mc=class_310.method_1551();
        if (mc.field_1687 == null||mc.field_1724==null) return;
        if (lastSlot!=-1){
            //破坏方块后切换回去
            mc.field_1724.method_31548().field_7545=lastSlot;
        }
    }
    @Subscribe
    private void onAttackBlock(PlayerAttackBlockEvent event){
        if(!FeaturesBool.autoTool) return;
        //自动工具
        class_310 mc=class_310.method_1551();
        if (mc.field_1687 == null||mc.field_1724==null) return;
        class_2680 state= mc.field_1687.method_8320(event.blockPos);
        //跳过不可破坏
        if(state.method_26214(mc.field_1687, event.blockPos) < 0) return;
        class_1799 currentItem = mc.field_1724.method_6047();
        //统计最好的挖掘分数
        double bestScore=-1;
        //工具槽
        int slot=-1;
        //遍历每一个物品槽
        for(int i=0;i<9;i++){
            class_1799 item = mc.field_1724.method_31548().method_5438(i);
            double score=getScore(item,state);
            if(score<0) continue;
            //选出最好分数的工具
            if(score>bestScore){
                bestScore=score;
                slot=i;
            }
        }
        //确定已经选择好了工具就切换
        if((slot!=-1&&bestScore>getScore(currentItem,state))||shouldStopUsing(currentItem)||!isTools(currentItem)) {
            //记住上一次的槽方便恢复
            lastSlot=mc.field_1724.method_31548().field_7545;
            //切换过去
            mc.field_1724.method_31548().field_7545 = slot;
        }
        if(isTools(currentItem)&&shouldStopUsing(currentItem)) {
            mc.field_1690.field_1886.method_23481(false);
        }
    }
    public double getScore(class_1799 item, class_2680 state){
        double score=0;
        //Is Tool!!
        if(item.method_7909() instanceof class_1831 || item.method_7909() instanceof class_1820){
            //根据挖掘速度提升评分
            score+=item.method_7924(state)*10;
            if (item.method_7909() instanceof class_1829 item1 && (state.method_26204() instanceof class_2211 || state.method_26204() instanceof class_2202))
                //根据挖掘等级加分
                score += 90 + (item1.method_8022().method_8024() * 10);
        }
        return score;
    }
    //停用低耐久度
    private boolean shouldStopUsing(class_1799 itemStack) {
        return  (itemStack.method_7936() - itemStack.method_7919()) < (itemStack.method_7936() * 6 / 100);
    }
    public boolean isTools(class_1799 item){
        return item.method_7909() instanceof class_1831 || item.method_7909() instanceof class_1820;
    }
}
